/*
 * @(#)MyContentHandler.java    Pzt 19 Nis 2010 14:06:16 EEST
 *
 * Murat iNAN, muratsivas76@gmail.com
 */
/*
*** This program wrote under GNU/General Public License ***

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.
*/

package net.dilmerkezi.xml;

import javax.swing.JComponent;
import javax.swing.JComboBox;
import javax.swing.JTextArea;
import javax.swing.JList;
import javax.swing.ListModel;
import javax.swing.text.JTextComponent;

import java.util.Vector;

import org.xml.sax.*;

/**
 * A ContentHandler implementation
 *
 * Murat iNAN, dilmerkezi.net/eng.html
 */
public final class MyContentHandler
        implements ContentHandler
{
    /** Components*/
    private JComponent [] comps;
    
    /** Components count*/
    private int complen;
    
    /** Text components*/
    private JTextComponent [][] twocmps;
    
    /** Text components count*/
    private int twolen;
    
    /** Active text component*/
    private JComponent activeCMP = null;
    
    /** Active component name*/
    private String activeName = "";
    
    /** Active flag*/
    private boolean flag = false;
    
    /** String buffer*/
    private StringBuffer sbuf = new StringBuffer ();
    
    
    /**
     * @param cmps Components
     * @param cmplen Components count
     * @param tmps Text components
     * @param tmpslen Text components count
     */
    public MyContentHandler (
        JComponent [] cmps, int cmplen,
        JTextComponent [][] tmps, int tmpslen)
    {
        this.comps = cmps;
        this.complen = cmplen;
        this.twocmps = tmps;
        this.twolen = tmpslen;
    }
    
    public void setDocumentLocator (Locator locator)
    {}
    
    public void startDocument ()
	throws SAXException
    {}
    
    public void endDocument()
	throws SAXException
    {}
    
    public void startPrefixMapping (String prefix, String uri)
	throws SAXException
    {}
    
    public void endPrefixMapping (String prefix)
	throws SAXException
    {}
    
    /** English flag */    private boolean en = false;
    /** Spanish flag */    private boolean es = false;
    /** German flag */     private boolean de = false;
    /** Danish flag */     private boolean dn = false;
    /** French flag */     private boolean fr = false;
    /** Portuguese flag */ private boolean pr = false;
    /** Turkish flag */    private boolean tr = false;

    /**
     * Founds current document
     *
     * @param uri XML path
     * @param localName Tag name
     * @param qName Tag name
     * @param atts tag attributes
     */
    public void startElement (String uri, String localName,
			      String qName, Attributes atts)
	throws SAXException
    {
        if (localName.equals ("English"))
        {
            en = true;
            de=false; fr=false; dn=false; 
            es=false; pr=false; tr=false;
        }
        else if (localName.equals ("German"))
        {
            de = true;
            en=false; fr=false; dn=false; 
            es=false; pr=false; tr=false;
        }
        else if (localName.equals ("French"))
        {
            fr = true; 
            en=false; de=false; dn=false; 
            es=false; pr=false; tr=false;
        }
        else if (localName.equals ("Danish"))
        {
            dn = true;
            en=false; de=false; es=false; 
            pr=false; tr=false; fr=false;
        }        
        else if (localName.equals ("Spanish"))
        {
            es = true;
            en=false; de=false; dn=false; 
            fr=false; pr=false; tr=false;
        }
        else if (localName.equals ("Portuguese"))
        {
            pr = true;
            en=false; de=false; dn=false; 
            es=false; fr=false; tr=false;
        }        
        else if (localName.equals ("Turkish"))
        {
            tr = true;
            en=false; de=false; dn=false; 
            es=false; pr=false; fr=false;
        }
        
        for (int i=0; i<complen; i++)
        {
            activeCMP = comps [i];
            if (activeCMP != null)
            {
                activeName = activeCMP.getName ();
                //System.out.println ("A Name: "+activeName+"");
            }
            if (activeCMP == null || activeName == null) 
            {
                flag = false;
                continue;
            }
            if (activeName.equalsIgnoreCase (localName))
            {
                flag = true;
                break;
            }
            else flag = false;
        }
        sbuf = new StringBuffer ();
        return;
    }
    
    /**
     * Closes flag
     *
     * @param uri XML path
     * @param localName Tag name
     * @param qName Tag name
     */
    public void endElement (String uri, String localName,
			    String qName)
	throws SAXException
    {
        /*
        if (activeCMP != null)
        {
            String name = activeCMP.getName ();
            if (name != null)
            {
                if (name.equals ("Char_Desc_2000"))
                {
                    return;
                }
            }
        }
        */
        if (localName.equals ("English"))
        {
            en = false;  
        }
        else if (localName.equals ("German"))
        {
            de = false;
        }
        else if (localName.equals ("French"))
        {
            fr = false; 
        }
        else if (localName.equals ("Danish"))
        {
            dn = false;
        }        
        else if (localName.equals ("Spanish"))
        {
            es = false;
        }
        else if (localName.equals ("Portuguese"))
        {
            pr = false;
        }        
        else if (localName.equals ("Turkish"))
        {
            tr = false;
        }
        flag = false;
    }
    
    private JComponent getCorrectComponent ()
    {
        if (activeCMP == null) return null;
            String name = activeCMP.getName ();
            if (name==null) return null;
            if (name.equals ("Keywords"))
            {
            if (en)
            {
                activeCMP = twocmps [0][1];
            }
            else if (es)
            {
                activeCMP = twocmps [1][1];
            }
            else if (de)
            {
                activeCMP = twocmps [2][1];
            }
            else if (dn)
            {
                activeCMP = twocmps [3][1];
            }
            else if (fr)
            {
                activeCMP = twocmps [4][1];
            }
            else if (pr)
            {
                activeCMP = twocmps [5][1];
            }
            else if (tr)
            {
                activeCMP = twocmps [6][1];
            }
            else 
            {
                activeCMP = twocmps [0][1];
            }
        }
        else if (name.equals ("Char_Desc_45"))
        {
            if (en)
            {
                activeCMP = twocmps [0][2];
            }
            else if (es)
            {
                activeCMP = twocmps [1][2];
            }
            else if (de)
            {
                activeCMP = twocmps [2][2];
            }
            else if (dn)
            {
                activeCMP = twocmps [3][2];
            }
            else if (fr)
            {
                activeCMP = twocmps [4][2];
            }
            else if (pr)
            {
                activeCMP = twocmps [5][2];
            }
            else if (tr)
            {
                activeCMP = twocmps [6][2];
            }
            else 
            {
                activeCMP = twocmps [0][1];
            }
        }
        else if (name.equals ("Char_Desc_80"))
        {
            if (en)
            {
                activeCMP = twocmps [0][3];
            }
            else if (es)
            {
                activeCMP = twocmps [1][3];
            }
            else if (de)
            {
                activeCMP = twocmps [2][3];
            }
            else if (dn)
            {
                activeCMP = twocmps [3][3];
            }
            else if (fr)
            {
                activeCMP = twocmps [4][3];
            }
            else if (pr)
            {
                activeCMP = twocmps [5][3];
            }
            else if (tr)
            {
                activeCMP = twocmps [6][3];
            }
            else 
            {
                activeCMP = twocmps [0][1];
            }
        }
        else if (name.equals ("Char_Desc_250"))
        {
            if (en)
            {
                activeCMP = twocmps [0][4];
            }
            else if (es)
            {
                activeCMP = twocmps [1][4];
            }
            else if (de)
            {
                activeCMP = twocmps [2][4];
            }
            else if (dn)
            {
                activeCMP = twocmps [3][4];
            }
            else if (fr)
            {
                activeCMP = twocmps [4][4];
            }
            else if (pr)
            {
                activeCMP = twocmps [5][4];
            }
            else if (tr)
            {
                activeCMP = twocmps [6][4];
            }
            else 
            {
                activeCMP = twocmps [0][1];
            }
        }
        else if (name.equals ("Char_Desc_450"))
        {
            if (en)
            {
                activeCMP = twocmps [0][5];
            }
            else if (es)
            {
                activeCMP = twocmps [1][5];
            }
            else if (de)
            {
                activeCMP = twocmps [2][5];
            }
            else if (dn)
            {
                activeCMP = twocmps [3][5];
            }
            else if (fr)
            {
                activeCMP = twocmps [4][5];
            }
            else if (pr)
            {
                activeCMP = twocmps [5][5];
            }
            else if (tr)
            {
                activeCMP = twocmps [6][5];
            }
            else 
            {
                activeCMP = twocmps [0][1];
            }
        }
        else if (name.equals ("Char_Desc_2000"))
        {
            if (en)
            {
                activeCMP = twocmps [0][6];
            }
            else if (es)
            {
                activeCMP = twocmps [1][6];
            }
            else if (de)
            {
                activeCMP = twocmps [2][6];
            }
            else if (dn)
            {
                activeCMP = twocmps [3][6];
            }
            else if (fr)
            {
                activeCMP = twocmps [4][6];
            }
            else if (pr)
            {
                activeCMP = twocmps [5][6];
            }
            else if (tr)
            {
                activeCMP = twocmps [6][6];
            }
            else 
            {
                activeCMP = twocmps [0][1];
            }
        }
            return activeCMP;    
    }
    
    /**
     * Current document set text
     *
     * @param ch Text characters
     * @param starts Text current start point
     * @param end Text current end point
     */
    public void characters (char ch[], int start, int length)
	throws SAXException
    {
        if (activeCMP != null && 
            activeCMP instanceof JTextComponent &&
            flag)
        {
            activeCMP = (JTextComponent)getCorrectComponent ();
            if (activeCMP == null) return;
            String str = new String (ch, start, length);
            String old = ((JTextComponent)(activeCMP)).getText ();
            ((JTextComponent)(activeCMP)).setText (old+str);
            return;
        }
        
        if (activeCMP != null && 
            activeCMP instanceof JComboBox &&
            flag)
        {
            String old = new String (ch, start, length);
            sbuf.append (old);
            JComboBox combo = (JComboBox)activeCMP;
            int cnt = combo.getItemCount ();
            String cstr = "";
            String str = sbuf.toString ();
            for (int i=0; i<cnt; i++)
            {
                cstr = (String)combo.getItemAt (i);
                if (cstr.equalsIgnoreCase (str))
                {
                    combo.setSelectedIndex (i);
                    break;
                }
            }
            return;
        }
        
        if (activeCMP != null && 
            activeCMP instanceof JList &&
            flag)
        {
            String old = new String (ch, start, length);
            String cstr = "";
            String [] strs = old.split (",");
            if (strs == null) return;
            int slen = strs.length;
            if (slen < 1) return;
            
            JList combo = (JList)activeCMP;
            ListModel model = combo.getModel ();
            int cnt = model.getSize ();
            
            Vector v = new Vector ();
            for (int i=0; i<slen; i++)
            {
                cstr = strs [i];
                for (int j=0; j<cnt; j++)
                {
                    String mdstr = (String)(model.getElementAt (j));
                    if (cstr.equalsIgnoreCase (mdstr))
                    {
                        String vs = Integer.toString (j);
                        if (v.contains (vs) == false)
                        {
                            v.addElement (Integer.toString (j));
                        }
                    }
                }
            }
            int size = v.size ();
            int [] ints = new int [size];
            for (int i=0; i<size; i++)
            {
                ints [i] = Integer.parseInt ((String)(v.get (i)));
            }
            
            combo.setSelectedIndices (ints);
            v.clear ();
            v = null;
            return;
        }

    }
    
    public void ignorableWhitespace (char ch[], int start, int length)
	throws SAXException
    {}
    
    public void processingInstruction (String target, String data)
	throws SAXException
    {}
    
    public void skippedEntity (String name)
	throws SAXException
    {
    System.out.println ("Skipped: "+name);
    }
    
}
//class end
